#!/usr/bin/env python

from __future__ import print_function

"""
A control agent for SignServer
        
"""

"""
RCSid:
	$Id: signctl.py,v 1.11 2015/12/31 05:56:07 sjg Exp $

	@(#) Copyright (c) 2012 Simon J. Gerraty

	This file is provided in the hope that it will
	be of use.  There is absolutely NO WARRANTY.
	Permission to copy, redistribute or otherwise
	use this file is hereby granted provided that 
	the above copyright notice and this notice are
	left intact. 
      
	Please send copies of changes and bug-fixes to:
	sjg@crufty.net

"""

if __name__ == '__main__':
    import sys, socket
    import getopt
    from sign import *
    from p3compat import *
    
    Myname = basename(sys.argv[0], '.py')
    Mydir = os.path.dirname(sys.argv[0])

    conf = {}

    myconf = Myname + '.cf'
    for d in [Mydir, '.']:
        cf = d + '/' + myconf
        if os.path.exists(cf):
            conf = loadConfig(cf, conf)

    debug = 0
    tries = 2
    opts,args = getopt.getopt(sys.argv[1:], 'dc:r:u:')
    for o,a in opts:
        if o == '-c':
            conf = loadConfig(a, conf)
        elif o == '-d':
            debug += 1
        elif o == '-r':
            tries = int(a)
        elif o == '-u':
            conf['url'] = a


    port = conf.get('ListenPort', 6161)
    url = conf.get('url', 'localhost:{}'.format(port))

    sock_family,connect_to = url2sock_address(url)

    sock,msg = urlconnect(sock_family, connect_to, tries)
    if not sock:
        sys.stderr.write(msg+'\n')
        sys.exit(1)
        
    for cmd in args:
        sock.send(b('signctl: {0}\n'.format(cmd)))
        while True:
            msg = sock.recv(1024)
            if not msg or msg.startswith(cmd) or msg.startswith('ERROR'):
                break

        if not msg:
            break
        
        if msg.startswith('ERROR'):
            sys.stderr.write(msg+'\n')
            sys.exit(1)
        print(msg)
